<html>
<head>
<title>OgreUserObjectBindings.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreUserObjectBindings.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreUserObjectBindings_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _UserObjectsBinding_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _UserObjectsBinding_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreAny_8h.html">OgreAny.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre {
<a name="l00035"></a>00035 
<a name="l00048"></a><a class="code" href="classOgre_1_1UserObjectBindings.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">public</span>: 
<a name="l00052"></a>00052         <a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>();
<a name="l00053"></a>00053 
<a name="l00055"></a>00055         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1UserObjectBindings.html" title="Class that provide convenient interface to establish a linkage between custom user application object...">UserObjectBindings</a>();
<a name="l00056"></a>00056 
<a name="l00066"></a>00066         <span class="keywordtype">void</span> setUserAny(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; anything);
<a name="l00067"></a>00067 
<a name="l00070"></a>00070         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; getUserAny(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00071"></a>00071 
<a name="l00080"></a>00080         <span class="keywordtype">void</span> setUserAny(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; key, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; anything);
<a name="l00081"></a>00081 
<a name="l00087"></a>00087         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; getUserAny(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; key) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00092"></a>00092         <span class="keywordtype">void</span> eraseUserAny(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; key);
<a name="l00093"></a>00093 
<a name="l00095"></a>00095         <span class="keywordtype">void</span> clear() <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00099"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#a6c22cddb800bc865eeb7faba941be2aa">00099</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>&amp; <a class="code" href="classOgre_1_1UserObjectBindings.html#a6c22cddb800bc865eeb7faba941be2aa" title="Returns empty user any object.">getEmptyUserAny</a>() { <span class="keywordflow">return</span> msEmptyAny; }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101     <span class="comment">// Types.</span>
<a name="l00102"></a>00102     <span class="keyword">protected</span>:      
<a name="l00103"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#a890438a17fbc73cb770c1d6ac9bcf028">00103</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html#a1e455b5b9d3d4a7d72c71a0b5d9e21ae">map&lt;String, Any&gt;::type</a>          <a class="code" href="classOgre_1_1UserObjectBindings.html#a890438a17fbc73cb770c1d6ac9bcf028">UserObjectsMap</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#aa097c83d883a487db6969601fddc8707">00104</a>         <span class="keyword">typedef</span> UserObjectsMap::iterator        <a class="code" href="classOgre_1_1UserObjectBindings.html#aa097c83d883a487db6969601fddc8707">UserObjectsMapIterator</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#ae7ce38b3d3cd1b4ffef57bf64c0f4dfa">00105</a>         <span class="keyword">typedef</span> UserObjectsMap::const_iterator  <a class="code" href="classOgre_1_1UserObjectBindings.html#ae7ce38b3d3cd1b4ffef57bf64c0f4dfa">UserObjectsMapConstIterator</a>;
<a name="l00106"></a>00106 
<a name="l00109"></a><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html">00109</a>         <span class="keyword">class </span><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html" title="Internal class that uses as data storage container.">Attributes</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">GeneralAllocatedObject</a>
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111         <span class="keyword">public</span>:
<a name="l00113"></a><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#a92b4ccee118aeb04abe13fbd89e6b499">00113</a>             <a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#a92b4ccee118aeb04abe13fbd89e6b499" title="Attribute storage ctor.">Attributes</a>() : mUserObjectsMap(NULL) {}
<a name="l00114"></a>00114 
<a name="l00116"></a><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#a801731adbf592a98e554cf7ff84606ea">00116</a>             ~<a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html" title="Internal class that uses as data storage container.">Attributes</a>()
<a name="l00117"></a>00117             {
<a name="l00118"></a>00118                 <span class="keywordflow">if</span> (mUserObjectsMap != NULL)
<a name="l00119"></a>00119                 {
<a name="l00120"></a>00120                     <a class="code" href="group__Memory.html#gad18eff671a00617b21c8e35a7f545690">OGRE_DELETE</a> mUserObjectsMap;
<a name="l00121"></a>00121                     mUserObjectsMap = NULL;
<a name="l00122"></a>00122                 }               
<a name="l00123"></a>00123             }
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#a0828aa0495e1b66e920284fc05018927">00125</a>             <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>                 <a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#a0828aa0495e1b66e920284fc05018927">mKeylessAny</a>;        <span class="comment">// Will hold key less associated user object for fast access.   </span>
<a name="l00126"></a><a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#ac16dc24d14ee81623ef72183820f8bbb">00126</a>             <a class="code" href="classOgre_1_1UserObjectBindings.html#a890438a17fbc73cb770c1d6ac9bcf028">UserObjectsMap</a>*     <a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html#ac16dc24d14ee81623ef72183820f8bbb">mUserObjectsMap</a>;    <span class="comment">// Will hold a map between user keys to user objects.</span>
<a name="l00127"></a>00127         };
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <span class="comment">// Attributes.</span>
<a name="l00130"></a>00130     <span class="keyword">private</span>:
<a name="l00131"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#a840b2d0cfb800a8d3c0b1adb408fbd6b">00131</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Any.html" title="Variant type that can hold Any other type.">Any</a>              <a class="code" href="classOgre_1_1UserObjectBindings.html#a840b2d0cfb800a8d3c0b1adb408fbd6b">msEmptyAny</a>;         <span class="comment">// Shared empty any object.</span>
<a name="l00132"></a><a class="code" href="classOgre_1_1UserObjectBindings.html#ad9b2a03db686c03b9f8b9253a88166c7">00132</a>         <span class="keyword">mutable</span> <a class="code" href="classOgre_1_1UserObjectBindings_1_1Attributes.html" title="Internal class that uses as data storage container.">Attributes</a>*     <a class="code" href="classOgre_1_1UserObjectBindings.html#ad9b2a03db686c03b9f8b9253a88166c7">mAttributes</a>;        <span class="comment">// Class attributes - will be allocated on demand.</span>
<a name="l00133"></a>00133         
<a name="l00134"></a>00134     };
<a name="l00135"></a>00135 
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
